Package com.io7m.coffeepick.api

# Interface CoffeePickSearchType

All Known Implementing Classes:
  `CoffeePickSearch`

    @Immutable
    public interface CoffeePickSearchType

Inventory search parameters.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `java.util.Optional<java.lang.String>` | `architecture()` |
  `java.util.Optional<RuntimeHash>` | `archiveHash()` |
  `java.util.OptionalLong` | `archiveSize()` |
  `java.util.Optional<java.net.URI>` | `archiveURI()` |
  `java.util.Optional<RuntimeConfiguration>` | `configuration()` |
  `java.util.Optional<java.lang.String>` | `id()` |
  `java.util.Optional<java.lang.String>` | `platform()` |
  `java.util.Optional<java.lang.String>` | `repository()` |
  `default java.util.Set<java.lang.String>` | `requiredTags()` |
  `java.util.Optional<RuntimeVersionRange>` | `versionRange()` |
  `java.util.Optional<java.lang.String>` | `vm()` |

- ## Method Details

  - ### repository

    java.util.Optional<java.lang.String> repository()
    Returns:
      The repository URI

  - ### versionRange

    java.util.Optional<RuntimeVersionRange> versionRange()
    Returns:
      The range of acceptable runtime versions

  - ### platform

    java.util.Optional<java.lang.String> platform()
    Returns:
      The name of the platform upon which this runtime will run

  - ### architecture

    java.util.Optional<java.lang.String> architecture()
    Returns:
      The name of the architecture upon which this runtime will run

  - ### vm

    java.util.Optional<java.lang.String> vm()
    Returns:
      The name of the VM used for this runtime

  - ### configuration

    java.util.Optional<RuntimeConfiguration> configuration()
    Returns:
      The configuration of the runtime

  - ### archiveURI

    java.util.Optional<java.net.URI> archiveURI()
    Returns:
      A URI that can be used to fetch an archive of the runtime

  - ### archiveSize

    java.util.OptionalLong archiveSize()
    Returns:
      The size in octets of the archive

  - ### archiveHash

    java.util.Optional<RuntimeHash> archiveHash()
    Returns:
      The hash of the runtime

  - ### id

    java.util.Optional<java.lang.String> id()
    Returns:
      The unique identifier of the runtime

  - ### requiredTags

    @Default default java.util.Set<java.lang.String> requiredTags()
    Returns:
      A set of tags that must be present on a given runtime